% lab10_ex_lagrange.m
% Interpolation using Lagrange polynomial
clear all; close all;

% ORIGINAL
%x = [ 0 1 ];  y=[0 0.5 ]; Sc=1;           % for linear interpolation
 x=[ -1 0 1 ]; y=[ 0 0.5 0.75 ]; Sc=1;     % for quadratic interpolation
%x=[-1 0 1 2]; y=[0 0.5 0.75 0.5 ]; Sc=6;  % for cubic interpolation
xi = -1 : 0.1 : 3;                         % function arguments of interest  
[p,L,yi1] = lagrangeTZ(x,y,xi);            % Lagrange interpolation function
yi2 = polyval(p,xi);                       % classical polynomial interpolation                
figure; plot(xi,yi1,'b-',xi,yi2,'k-',x,y,'ro'); title('y(k) and y(n)'); % result
Lagrange = L,  pause         % coefficients of Lagrange polynomials in rows
Farrow = L', pause           % coefficients of Farrow filters in rows